---
openapi: "3.0.0"
info:
  title: "Feedback API"
  description: "The <b>Feedback API</b> includes resources for retrieving items awaiting\
    \ feedback, retrieving and submitting feedback entries, providing feedback rating\
    \ summaries, and responding to feedback. These methods allow users to manage feedback\
    \ across buying and selling activities. <p><span class=\"tablenote\"><span style=\"\
    color:#004680\"><strong>Note: </strong>Feedback is tracked at the line item level\
    \ within an order, not for the whole order. Each line item can have its own feedback\
    \ record.</span></p>"
  contact:
    name: "eBay Inc,"
  license:
    name: "eBay API License Agreement"
    url: "https://developer.ebay.com/join/api-license-agreement"
  version: "v1.0.0"
servers:
- url: "https://api.ebay.com{basePath}"
  description: "Production"
  variables:
    basePath:
      default: "/commerce/feedback/v1"
paths:
  /awaiting_feedback:
    get:
      tags:
      - "awaiting_feedback"
      description: "This method retrieves line items awaiting feedback from the user's\
        \ order partner. You can refine the results using optional filter query parameters,\
        \ such as item ID, user name, or user role in the transaction. Sorting and\
        \ pagination features help organize and navigate returned items efficiently.<p>For\
        \ sellers, only sold items that have not yet received feedback are included.\
        \ For buyers, only purchased items for which feedback is still pending are\
        \ included. If the user is both a buyer and a seller, this API returns items\
        \ awaiting feedback for transactions where the user acted as either. Applying\
        \ filters can limit results to either buyer-only or seller-only transactions.\
        \ </p><p>The response provides an overview of feedback yet to be left for\
        \ completed transactions (as filtered), with counts for both the buyer and\
        \ seller roles. It includes an array of line items, each containing the listing\
        \ ID, title, price (with currency and value). For each line item, the response\
        \ offers feedback templates specifying which ratings are available.</p><p><span\
        \ class=\"tablenote\"><span style=\"color:#004680\"><strong>Note: </strong>Detailed\
        \ seller ratings are for sellers only, and are created from buyer feedback.</span></p>"
      operationId: "getItemsAwaitingFeedback"
      parameters:
      - name: "filter"
        in: "query"
        description: "Use this parameter to limit the response based on the specified\
          \ filter parameters. Supported filter parameters include:<br><p><ul><li><b>listingId</b>:\
          \ Filter results by the specific listing ID</li><li><b>receiverName</b>:\
          \ Filter results by the user's order partner name involved in the transaction</li><li><b>userRole</b>:\
          \ Use this filter to only retrieve feedback due from the user in role as\
          \ a seller or a buyer. If this filter is not used, all feedback due in both\
          \ user roles is retrieved (<code>BUYER</code> or <code>SELLER</code>)</li></ul></p><p>Send\
          \ the filter as a query parameter in a comma-separated <em>name</em>:<em>value</em>\
          \ list. For example: <br><code>filter=listingId:123,receiverName:user,userRole:BUYER</code><p>"
        required: false
        schema:
          type: "string"
      - name: "limit"
        in: "query"
        description: "This parameter sets the maximum number of line items to return\
          \ per page of data.<br><p>Use this parameter in conjunction with the <b>offset</b>\
          \ parameter to control the pagination of the output. For example, with offset\
          \ set to <code>20</code> and limit set to <code>10</code>, the call retrieves\
          \ entries 21 through 30 from the result set.</p><p> Although this field\
          \ is optional, if omitted the default value of <code>25</code> is used.</p><p><b>Default:\
          \ </b>25</p><p><b>Minimum: </b>25</p><p><b>Maximum: </b>200</p>"
        required: false
        schema:
          type: "string"
      - name: "offset"
        in: "query"
        description: "Use this parameter to specify the number of items to skip in\
          \ the result set. This is used with the <code>limit</code> field to control\
          \ the pagination of the output. For example:<br><ul><li>If <b>offset</b>\
          \ is <code>0</code> and <b>limit</b> is <code>10</code>, the method will\
          \ retrieve items 1-10 from the list of line items returned</li><li>If <b>offset</b>\
          \ is <code>10</code> and <b>limit</b> is <code>10</code>, the method will\
          \ retrieve items 11-20 from the list of line items returned.</li></ul><p><span\
          \ class=\"tablenote\"><span style=\"color:#004680\"><strong>Note: </strong>This\
          \ feature employs a zero-based list, where the first line item in the list\
          \ has an offset of 0.</span></p><p>If this parameter is not set, its value\
          \ defaults to <code>0</code> which returns the first page of records.</p><p><b>Default:</b>\
          \ 0</p>"
        required: false
        schema:
          type: "string"
      - name: "sort"
        in: "query"
        description: "Use this parameter to configure the order of the returned listings.\
          \ The time is based on when the buyer paid for the line item. Acceptable\
          \ values:<br><ul><li><b>END_TIME_ASC:</b> Sorts listings by end time from\
          \ oldest to newest</li><li><b>END_TIME_DESC:</b> Sorts listings by end time\
          \ from newest to oldest (default)</li></ul><p>If this parameter is omitted,\
          \ its value defaults to <b>END_TIME_DESC</b>.</p><p><b>Default: </b><code>END_TIME_DESC</code></p>"
        required: false
        schema:
          type: "string"
      responses:
        "200":
          description: "Success"
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/AwaitingFeedbackResponse"
        "400":
          description: "Bad Request"
          x-response-codes:
            errors:
              501025:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Input user role value is invalid."
              501024:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Input sort value is invalid."
        "500":
          description: "Internal Server Error"
          x-response-codes:
            errors:
              2003:
                domain: "API_FEEDBACK"
                category: "APPLICATION"
                description: "There was a problem with an eBay internal system or\
                  \ process. Contact eBay developer support for assistance."
        "401":
          description: "Not Authorized"
          x-response-codes:
            errors:
              1001:
                domain: "API_FEEDBACK"
                category: "APPLICATION"
                description: "Invalid access token. Check the value of the Authorization\
                  \ HTTP request header."
      security:
      - api_auth:
        - "https://api.ebay.com/oauth/api_scope/commerce.feedback"
  /feedback:
    get:
      tags:
      - "feedback"
      description: "This method enables users to retrieve feedback for any specified\
        \ user ID and feedback type (sent or received). You can refine the results\
        \ using optional query parameters such as its feedback ID, listing ID, or\
        \ order line item ID, or applying one or more filters.<p>Applying filters\
        \ can narrow results using criteria such as comment type, photos, or topics\
        \ identified through AI-based analysis. When filtering for feedback with photos\
        \ (<code>filterImage:true</code>), only entries with images (entries that\
        \ include image URLs) are returned. Additionally, feedback can be refined\
        \ for the number of days to look back, the role of the user providing the\
        \ feedback, and whether to include automated feedback entries left by eBay.</p><p>Sorting\
        \ and pagination features help organize and navigate returned items efficiently.</p><p>Returned\
        \ data includes feedback details (such as comment text and type), feedback\
        \ ratings (covering criteria like overall experience, and for sellers item\
        \ description, shipping time, and communication), role and attributes of the\
        \ feedback giver, line item and transaction summaries, images, and any available\
        \ topics. See <a href=\"/api-docs/commerce/feedback/resources/feedback/methods/getFeedback#uri.filter\"\
        \ >filter</a> for additional information. Privacy is safeguarded by restricting\
        \ the amount of detail visible to users, depending on their context. When\
        \ accessing another user's feedback without logging in, buyer names are masked\
        \ and seller names are shown. Logged-in users viewing their own feedback see\
        \ all names, while those viewing other users' feedback will encounter some\
        \ masking.</p>"
      operationId: "getFeedback"
      parameters:
      - name: "feedback_id"
        in: "query"
        description: "Use this field to only return a specific feedback record by\
          \ its feedback ID. <br><p><span class=\"tablenote\"><span style=\"color:#004680\"\
          ><strong>Note: </strong>If this query parameter is used, no other filters\
          \ will be applicable.</span></p>"
        required: false
        schema:
          type: "string"
      - name: "feedback_type"
        in: "query"
        description: "Use this field to specify the type of feedback records to return.\
          \ Acceptable values: <br><ul><li><b>FEEDBACK_RECEIVED</b>: Retrieve feedback\
          \ received by the specified user.</li><li><b>FEEDBACK_SENT</b>: Retrieve\
          \ feedback sent by the specified user.</li></ul><p>If not specified, both\
          \ feedback received and feedback left for the user shall be retrieved.</p><p><span\
          \ class=\"tablenote\"><span style=\"color:#004680\"><strong>Note: </strong>When\
          \ using <b>FEEDBACK_SENT</b>, it is recommended to also filter <b>feedback_id</b>\
          \ to target results accurately.</span></p>"
        required: true
        schema:
          type: "string"
      - name: "filter"
        in: "query"
        description: "Use this parameter to limit the response based on the specified\
          \ filter parameters as follows: <br><ul><li><b>commentType</b>: Return only\
          \ feedback with the set type of comments. Comment types available: <code>POSITIVE</code>,\
          \ <code>NEUTRAL</code>, or <code>NEGATIVE</code> <p><span class=\"tablenote\"\
          ><span style=\"color:#004680\"><strong>Note: </strong>Sellers can only provide\
          \ positive feedback.</span></p> </li><li><b>filterImage</b>: Return feedback\
          \ dependent on if images are included. Filter values available:<ul><li><code>true</code>:\
          \ Return only feedback with images</li><li><code>false</code>: Return feedback\
          \ with or without images</li></ul></li><li><b>topics</b>: Use AI to generate\
          \ items returned that are associated to the set topic. For example, if you\
          \ set <code>topics:shipping</code>, only feedback comments about shipping\
          \ are returned. Topics available: <code>shipping</code>, <code>service</code>,\
          \ <code>packaging</code>, <code>description</code>, <code>seller-satisfaction</code>,\
          \ <code>overall-satisfaction</code>, <code>refund</code>, <code>inventory</code>,\
          \ <code>customer loyalty</code>, <code>seller-other</code>, <code>quality</code>,\
          \ <code>price</code>, <code>condition</code>, <code>fit</code>, <code>appearance</code>,\
          \ <code>dimensions</code>, <code>usage</code>, <code>product-satisfaction</code>,\
          \ <code>product-other</code>, <code>extras</code><br><br>See <a href=\"\
          /develop/guides-v2/communications/sell-communications-guide#retrieve-ai-filtered-items\"\
          \ target=\"_blank\">Retrieve AI-filtered feedback</a> for an example.</li><li><b>period</b>:\
          \ Filter results by the number of days to look back for feedback. If not\
          \ set, lifetime results are returned. Supported values available: <code>7</code>,\
          \ <code>30</code>, <code>90</code>, <code>180</code>, or <code>365</code></li><li><b>role</b>:\
          \ Filter results by the role of the user providing feedback. Roles available:\
          \ <code>BUYER </code>or <code>SELLER</code></li><li><b>showAutomatedFeedback</b>:\
          \ Filter results to include automated feedback left by eBay  entries. For\
          \ sellers with less than a 10 feedback score, an automated feedback message\
          \ on behalf of eBay is returned.<ul><li><code>true</code>: Return automated\
          \ feedback including both user and eBay generated feedback</li><li><code>false</code>:\
          \ Do not return eBay's automatic feedback for seller in response (default)</li></ul></li></ul>Send\
          \ the filter as a query parameter in a comma-separated <em>name</em>:<em>value</em>\
          \ list. For example:  <br><br><code>filter=commentType:POSITIVE,filterImage:true,topics:fit,period:30,role:SELLER,showAutomatedFeedback:true</code></p>"
        required: false
        schema:
          type: "string"
      - name: "limit"
        in: "query"
        description: "Use this parameter to set the maximum number of items to return\
          \ per page of data.<br><p>Use this parameter in conjunction with the <b>offset</b>\
          \ parameter to control the pagination of the output. For example, with offset\
          \ set to <code>20</code> and limit set to <code>10</code>, the call retrieves\
          \ entries 21 through 30 from the result set.</p><p> Although this field\
          \ is optional, if omitted the default value of <code>25</code> is used.</p><p><b>Default:\
          \ </b>25</p><p><b>Minimum: </b>25</p><p><b>Maximum: </b>200</p>"
        required: false
        schema:
          type: "string"
      - name: "listing_id"
        in: "query"
        description: "Use this field to limit feedback entries to those associated\
          \ with a specified listing."
        required: false
        schema:
          type: "string"
      - name: "offset"
        in: "query"
        description: "Use this field to specify the number of line items to skip in\
          \ the result set. This is used with the <code>limit</code> field to control\
          \ the pagination of the output. For example:<br><ul><li>If <b>offset</b>\
          \ is <code>0</code> and <b>limit</b> is <code>10</code>, the method will\
          \ retrieve items 1-10 from the list of line items returned</li><li>If <b>offset</b>\
          \ is <code>10</code> and <b>limit</b> is <code>10</code>, the method will\
          \ retrieve items 11-20 from the list of line items returned.</li></ul><p><span\
          \ class=\"tablenote\"><span style=\"color:#004680\"><strong>Note: </strong>This\
          \ feature employs a zero-based list, where the first line item in the list\
          \ has an offset of 0.</span></p><p>If this parameter is not set, its value\
          \ defaults to <code>0</code> which returns the first page of records.</p><p><b>Default:</b>\
          \ 0</p>"
        required: false
        schema:
          type: "string"
      - name: "order_line_item_id"
        in: "query"
        description: "Use this field to retrieve specific feedback entries related\
          \ to an order line item ID. A maximum of two entries may be retrieved: feedback\
          \ left by the buyer and feedback left by the seller. <br><p><span class=\"\
          tablenote\"><span style=\"color:#004680\"><strong>Note: </strong>If this\
          \ query parameter is set, no other filters will be applicable.</span></p>"
        required: false
        schema:
          type: "string"
      - name: "sort"
        in: "query"
        description: "Use this parameter to configure the order of the returned items.\
          \ The time is based on when the buyer paid for the line item. Acceptable\
          \ values:<br><ul><li><b>RELEVANCE</b>: Sorts items by relevance (default).\
          \ This sort takes into account any available factors such as a comment score,\
          \ comment type (positive, negative, neutral), how long ago the comment was\
          \ left, or the length of the comment</li><li><b>TIME</b>: Sorts items by\
          \ end time from newest to oldest.</li></ul><p>If this parameter is omitted,\
          \ its value defaults to <b>RELEVANCE</b>.</p><p><b>Default: </b><code>RELEVANCE</code></p>"
        required: false
        schema:
          type: "string"
      - name: "transaction_id"
        in: "query"
        description: "Use this field to limit feedback entries to those associated\
          \ with the specified transaction ID."
        required: false
        schema:
          type: "string"
      - name: "user_id"
        in: "query"
        description: "Use this field to specify the unique identifier user ID (eBay\
          \ username of the user) of the account for which feedback is being retrieved.<br><br><span\
          \ class=\"tablenote\"><b>Note:</b> Both usernames and public user IDs will\
          \ be accepted in this field. For more information, please refer to <a href=\"\
          /api-docs/static/data-handling-update.html\" target=\"_blank\">Data Handling\
          \ Compliance</a>.</span>"
        required: true
        schema:
          type: "string"
      responses:
        "200":
          description: "Success"
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/GetFeedbackResponse"
        "400":
          description: "Bad Request"
          x-response-codes:
            errors:
              501025:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Input user role value is invalid."
              501039:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Feedback not found for the given request parameters."
              501038:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Invalid topics value. Must be from the allowed topics\
                  \ list."
              501037:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Invalid period value. Must be 30, 60, or 365."
              501036:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Invalid overall rating value. Must be POSITIVE, NEUTRAL,\
                  \ or NEGATIVE."
              501035:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Invalid sort type value. Must be RELEVANCE or TIME."
              501003:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Listing id request parameter is invalid."
              501002:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Unsupported request parameter combination."
              501001:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Feedback type request parameter is required or invalid.\
                  \ Must be FEEDBACK_RECEIVED or FEEDBACK_SENT."
              501000:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Username request parameter is required or is invalid."
        "500":
          description: "Internal Server Error"
          x-response-codes:
            errors:
              2003:
                domain: "API_FEEDBACK"
                category: "APPLICATION"
                description: "There was a problem with an eBay internal system or\
                  \ process. Contact eBay developer support for assistance."
        "401":
          description: "Not Authorized"
          x-response-codes:
            errors:
              1001:
                domain: "API_FEEDBACK"
                category: "APPLICATION"
                description: "Invalid access token. Check the value of the Authorization\
                  \ HTTP request header."
      security:
      - api_auth:
        - "https://api.ebay.com/oauth/api_scope/commerce.feedback"
        - "https://api.ebay.com/oauth/api_scope/commerce.feedback.readonly"
    post:
      tags:
      - "feedback"
      description: "This method creates and submits feedback to the user's order partner\
        \ for a line item in the order. For each order, the order partner is the other\
        \ participant in the transaction, either the buyer or seller, depending on\
        \ the eBay user associated with the user token. This method allows users to\
        \ provide detailed information about the transaction, including the feedback\
        \ rating, comments, and seller delivery. You can also add images to your feedback.<p><span\
        \ class=\"tablenote\"><span style=\"color:#004680\"><strong>Note: </strong>A\
        \ seller can only provide a comment for a buyer, but a buyer can provide a\
        \ comment plus provides ratings on a number of metrics for a seller.</span></p>\
        \ <p><span class=\"tablenote\"><span style=\"color:#004680\"><strong>Note:\
        \ </strong>The feedback must adhere to community guidelines and be relevant\
        \ to the transaction.</span></p> <p>When leaving feedback, keep the following\
        \ in mind:<ul><li>Your feedback score is not affected when you leave feedback</li><li>Feedback\
        \ can only be revised once after it is submitted</li></ul></p><p>For additional\
        \ information on leaving feedback, see the following:<ul><li><a href=\"https://www.ebay.com/help/buying/leaving-feedback-sellers/leaving-feedback-sellers?id=4007\"\
        \  target=\"_blank\">Leaving feedback for sellers</a></li><li><a href=\"https://www.ebay.com/help/selling/leaving-feedback-buyers/leaving-feedback-buyers?id=4078\"\
        \  target=\"_blank\">Leaving feedback for buyers</a></li></ul></p><p>A successful\
        \ call to this method returns a feedback ID, which is a unique identifier\
        \ for the newly created feedback and allows for reference and tracking. </p>"
      operationId: "leaveFeedback"
      parameters:
      - name: "Content-Type"
        in: "header"
        description: "This header indicates the format of the request body provided\
          \ by the client. Its value should be set to <b>application/json</b>. <br><br>\
          \ For more information, refer to <a href=\"/api-docs/static/rest-request-components.html#HTTP\"\
          \ target=\"_blank \">HTTP request headers</a>."
        required: true
        schema:
          type: "string"
      requestBody:
        description: "Request body for leaving feedback. Required fields: commentText\
          \ (the text of the feedback comment), commentType (acceptable values - [POSITIVE,\
          \ NEUTRAL, NEGATIVE]), listingId (the listingId of the item the feedback\
          \ is being left for), transactionId (the transactionId for the order), orderLineItemId\
          \ (Search by order line item ID. order line item id is a concatenation of\
          \ listing ID and transaction ID, joined by `-`. Ex `listing_id-transaction_id`),\
          \ sellerRatings (array of ratings with keys - [ON_TIME_DELIVERY, ITEM_AS_DESCRIBED,\
          \ COMMUNICATION, SHIPPING_CHARGES, SHIPPING_TIME]), images (array of images\
          \ with url field, can add upto 5 images)"
        content:
          application/json:
            schema:
              description: "Request body for leaving feedback. Required fields: commentText\
                \ (the text of the feedback comment), commentType (acceptable values\
                \ - [POSITIVE, NEUTRAL, NEGATIVE]), listingId (the listingId of the\
                \ item the feedback is being left for), transactionId (the transactionId\
                \ for the order), orderLineItemId (Search by order line item ID. order\
                \ line item id is a concatenation of listing ID and transaction ID,\
                \ joined by `-`. Ex `listing_id-transaction_id`), sellerRatings (array\
                \ of ratings with keys - [ON_TIME_DELIVERY, ITEM_AS_DESCRIBED, COMMUNICATION,\
                \ SHIPPING_CHARGES, SHIPPING_TIME]), images (array of images with\
                \ url field, can add upto 5 images)"
              $ref: "#/components/schemas/LeaveFeedbackRequest"
        required: false
      responses:
        "200":
          description: "Success"
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/LeaveFeedbackResponse"
        "400":
          description: "Bad Request"
          x-response-codes:
            errors:
              501007:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Seller ratings are not valid type."
              501006:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Comment type request parameter is invalid."
              501005:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Comment text request parameter is invalid."
              501004:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Transaction id request parameter is invalid."
              501003:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Listing id request parameter is invalid."
              501034:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Only 5 images can be attached to a feedback."
              501015:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Comment text contains profanity."
              501014:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Comment text value is invalid."
              501013:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Comment text is too long, maximum length is 500 characters."
              501019:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "On time delivery rating value is invalid."
              501018:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Item rating type is invalid."
              501017:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Seller ratings type is not supported for this provider\
                  \ role."
              501016:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Seller ratings value is invalid."
        "500":
          description: "Internal Server Error"
          x-response-codes:
            errors:
              2003:
                domain: "API_FEEDBACK"
                category: "APPLICATION"
                description: "There was a problem with an eBay internal system or\
                  \ process. Contact eBay developer support for assistance."
        "401":
          description: "Not Authorized"
          x-response-codes:
            errors:
              1001:
                domain: "API_FEEDBACK"
                category: "APPLICATION"
                description: "Invalid access token. Check the value of the Authorization\
                  \ HTTP request header."
        "409":
          description: "Conflict"
          x-response-codes:
            errors:
              501012:
                domain: "API_FEEDBACK"
                category: "BUSINESS"
                description: "Feedback provider is relatively new to eBay. Provider\
                  \ should be at least 5 days on ebay."
              501011:
                domain: "API_FEEDBACK"
                category: "BUSINESS"
                description: "Feedback provider is not eligible to leave feedback."
              501010:
                domain: "API_FEEDBACK"
                category: "BUSINESS"
                description: "Feedback receiver is not eligible to receive feedback."
              501009:
                domain: "API_FEEDBACK"
                category: "BUSINESS"
                description: "Leaving feedback for this listing is blocked due to\
                  \ policy, please contact eBay support."
              501008:
                domain: "API_FEEDBACK"
                category: "BUSINESS"
                description: "Feedback already left for this listing."
              501021:
                domain: "API_FEEDBACK"
                category: "BUSINESS"
                description: "Seller cannot receive negative or neutral feedback."
              501020:
                domain: "API_FEEDBACK"
                category: "BUSINESS"
                description: "Seller cannot leave negative or neutral feedback."
      security:
      - api_auth:
        - "https://api.ebay.com/oauth/api_scope/commerce.feedback"
  /feedback_rating_summary:
    get:
      tags:
      - "feedback_rating_summary"
      description: "This method provides a detailed overview of feedback ratings associated\
        \ with a user in the eBay marketplace. Specify a user ID and apply filters\
        \ to retrieve summarized feedback data categorized by rating types and user\
        \ roles. These returned metrics are aggregated, which offers insight into\
        \ user experiences and performance. <p class=\"msgbox_tipInDiv\" ><div class=\"\
        msgbox_tip\"><span><b><span style=\"color: #478415;\">Tip:</span></b></span></span>\
        \ You can use this method to help sellers and buyers understand their marketplace\
        \ reputation and identify areas for improvement.</div></p><p>Returned data\
        \ provides a summary of feedback ratings for a user by rating type (such as\
        \ overall experience, communication, or delivery timeliness) for both buyer\
        \ and seller roles. Each type of rating includes aggregated metrics like averages,\
        \ counts, unique feedback givers, and the percentage of positive ratings (excluding\
        \ neutrals). The response also details the distribution of specific rating\
        \ values, their frequency, and time period (with period units like days or\
        \ months) over which these metrics were calculated.</p>"
      operationId: "getFeedbackRatingSummary"
      parameters:
      - name: "filter"
        in: "query"
        description: "Use this parameter to limit the response based on specified\
          \ filter values:<br><ul><li><b>ratingType</b>: Specifies the type of rating\
          \ being summarized and returned <b>(Required)</b>. Available values: <code>OVERALL_EXPERIENCE</code>,\
          \ <code>OVERALL_EXPERIENCE_COMMENT</code>, <code>ON_TIME_DELIVERY</code>,\
          \ <code>DSR_ITEM_AS_DESCRIBED</code>, <code>DSR_COMMUNICATION</code>, <code>DSR_SHIPPING_CHARGES</code>,\
          \ <code>DSR_SHIPPING_TIME</code>, <code>ITEM_RATING</code><br>See <a href=\"\
          /api-docs/commerce/feedback/types/fdb:FeedbackRatingTypeEnum\" >FeedbackRatingTypeEnum</a>\
          \ for descriptions of values. </li><li><b>excludeRepeatFeedback</b>: Set\
          \ to <code>true</code> to exclude repeat feedback.</li><li><b>lookbackPeriodInDays</b>:\
          \ Limit the response to a previous period of days. Available values: <code>7</code>,\
          \ <code>30</code>, <code>90</code>, <code>180</code>, or <code>365</code></li></ul><p>You\
          \ can send the filter as a query parameter, either with the required <b>ratingType</b>\
          \ only, or combining the filter values with a comma-separated <em>name</em><b>:</b><em>value</em>\
          \ list. For example:</p><p><code>filter=ratingType:OVERALL_EXPERIENCE,excludeRepeatFeedback:true,period:365</code></p>"
        required: true
        schema:
          type: "string"
      - name: "user_id"
        in: "query"
        description: "Use this parameter to specify the unique identifier (the eBay\
          \ username associated with the account) for the eBay user whose feedback\
          \ summary is being retrieved."
        required: true
        schema:
          type: "string"
      responses:
        "200":
          description: "Success"
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/GetFeedbackRatingSummaryResponse"
        "400":
          description: "Bad Request"
          x-response-codes:
            errors:
              501007:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Seller ratings are not valid type."
              501022:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Rating type request parameter is invalid."
              501037:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Invalid period value. Must be 30, 60, or 365."
              501002:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Unsupported request parameter combination."
        "500":
          description: "Internal Server Error"
          x-response-codes:
            errors:
              2003:
                domain: "API_FEEDBACK"
                category: "APPLICATION"
                description: "There was a problem with an eBay internal system or\
                  \ process. Contact eBay developer support for assistance."
        "401":
          description: "Not Authorized"
          x-response-codes:
            errors:
              1001:
                domain: "API_FEEDBACK"
                category: "APPLICATION"
                description: "Invalid access token. Check the value of the Authorization\
                  \ HTTP request header."
        "404":
          description: "Not Found"
          x-response-codes:
            errors:
              501023:
                domain: "API_FEEDBACK"
                category: "APPLICATION"
                description: "Feedback rating summary user not found."
      security:
      - api_auth:
        - "https://api.ebay.com/oauth/api_scope/commerce.feedback"
        - "https://api.ebay.com/oauth/api_scope/commerce.feedback.readonly"
  /respond_to_feedback:
    post:
      tags:
      - "respond_to_feedback"
      description: "This method allows users to respond to feedback provided by the\
        \ order partner for a specific line item in an order. For each order, the\
        \ order partner is the other participant in the transaction, either the buyer\
        \ or seller, depending on the eBay user associated with the user token. This\
        \ method allows the user to provide additional context or address the order\
        \ partner's feedback.<p><span class=\"tablenote\"><span style=\"color:#004680\"\
        ><strong>Note: </strong>The feedback response must adhere to community guidelines\
        \ and be relevant to the transaction.</span></p><p>You can only use this method\
        \ if feedback has been provided by the order partner and you have not yet\
        \ responded to it. </p> <p>When responding to feedback, your feedback score\
        \ is not affected when you respond to feedback.</p><p>For additional information\
        \ on leaving feedback, see the following:<ul><li><a href=\"https://www.ebay.com/help/buying/leaving-feedback-sellers/leaving-feedback-sellers?id=4007\"\
        \  target=\"_blank\">Leaving feedback for sellers</a></li><li><a href=\"https://www.ebay.com/help/selling/leaving-feedback-buyers/leaving-feedback-buyers?id=4078\"\
        \  target=\"_blank\">Leaving feedback for buyers</a></li></ul></p><p>A successful\
        \ call returns an HTTP status of <b>200 Success</b>.</p>"
      operationId: "respondToFeedback"
      parameters:
      - name: "Content-Type"
        in: "header"
        description: "This header indicates the format of the request body provided\
          \ by the client. Its value should be set to <b>application/json</b>. <br><br>\
          \ For more information, refer to <a href=\"/api-docs/static/rest-request-components.html#HTTP\"\
          \ target=\"_blank \">HTTP request headers</a>."
        required: true
        schema:
          type: "string"
      requestBody:
        description: "This provides the request body for responding to feedback."
        content:
          application/json:
            schema:
              description: "This provides the request body for responding to feedback."
              $ref: "#/components/schemas/RespondToFeedbackRequest"
        required: false
      responses:
        "200":
          description: "Success"
          content:
            application/json:
              schema:
                type: "object"
        "400":
          description: "Bad Request"
          x-response-codes:
            errors:
              501015:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Comment text contains profanity."
              501014:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Comment text value is invalid."
              501013:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Comment text is too long, maximum length is 500 characters."
              501029:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Recipient user ID request parameter is required."
              501028:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Response text request parameter is required."
              501027:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Response type request parameter is required or is invalid.\
                  \ Must be REPLY or FOLLOW_UP."
              501026:
                domain: "API_FEEDBACK"
                category: "REQUEST"
                description: "Feedback ID request parameter is required or is invalid."
        "401":
          description: "Not Authorized"
          x-response-codes:
            errors:
              1001:
                domain: "API_FEEDBACK"
                category: "APPLICATION"
                description: "Invalid access token. Check the value of the Authorization\
                  \ HTTP request header."
        "500":
          description: "Internal Server Error"
          x-response-codes:
            errors:
              2003:
                domain: "API_FEEDBACK"
                category: "APPLICATION"
                description: "There was a problem with an eBay internal system or\
                  \ process. Contact eBay developer support for assistance."
        "403":
          description: "Forbidden"
          x-response-codes:
            errors:
              501031:
                domain: "API_FEEDBACK"
                category: "BUSINESS"
                description: "Reply not allowed for automated feedback."
        "409":
          description: "Conflict"
          x-response-codes:
            errors:
              501011:
                domain: "API_FEEDBACK"
                category: "BUSINESS"
                description: "Feedback provider is not eligible to leave feedback."
              501033:
                domain: "API_FEEDBACK"
                category: "BUSINESS"
                description: "Follow up comment already left for feedback."
              501032:
                domain: "API_FEEDBACK"
                category: "BUSINESS"
                description: "Reply already left for feedback."
      security:
      - api_auth:
        - "https://api.ebay.com/oauth/api_scope/commerce.feedback"
components:
  schemas:
    AwaitingFeedback:
      type: "object"
      properties:
        listingId:
          type: "string"
          description: "This is the unique identifier for the listing associated with\
            \ the line item. It is used to reference the specific listing for which\
            \ feedback is being awaited."
        listingPrice:
          description: "This container shows the sales price of the listing."
          $ref: "#/components/schemas/ListingPrice"
        listingTitle:
          type: "string"
          description: "The title of the listing."
        orderLineItemId:
          type: "string"
          description: "The unique identifier for the eBay order line item associated\
            \ with the listing. It is used to pinpoint the exact line item for which\
            \ feedback is being awaited."
        ratingTemplates:
          type: "array"
          description: "This array contains a list of available values for use in\
            \ a particular rating, and whether the value is enabled. This is dependent\
            \ on what seller ratings the buyer's order partner qualifies.<br><p><span\
            \ class=\"tablenote\"><span style=\"color:#004680\"><strong>Note: </strong>Rating\
            \ templates should only be returned to the user in their role as a buyer;\
            \ only sellers have Detailed Seller Ratings (DSRs). </span></p><p>Use\
            \ the metadata returned here when leaving DSR ratings through the <b>leaveFeedback</b>\
            \ method. The key field in this container is the <b>ratingKey</b> field.\
            \ See <a href=\"/api-docs/commerce/feedback/types/fdb:FeedbackRatingTypeEnum\"\
            \ >FeedbackRatingTypeEnum</a> for its values. The other metadata returned\
            \ in this container apply to each <b>ratingKey</b> value that is returned.</p>"
          items:
            $ref: "#/components/schemas/FeedbackRatingTemplateType"
        transactionId:
          type: "string"
          description: "The unique identifier of the sales transaction."
      description: "This type contains the details for each line item awaiting feedback."
    AwaitingFeedbackResponse:
      type: "object"
      properties:
        itemsAwaitingFeedbackCount:
          description: "This container returns the number of line items awaiting feedback.\
            \ The <b>asSeller</b> and <b>asBuyer</b> fields return the total count\
            \ of items awaiting feedback as seller and buyer and are not affected\
            \ by the <b>userRole</b> filter."
          $ref: "#/components/schemas/ItemsAwaitingFeedbackCount"
        lineItems:
          type: "array"
          description: "This array contains the details for each line item awaiting\
            \ feedback. An empty array is returned if no line items are awaiting feedback\
            \ or that match the filter criteria."
          items:
            $ref: "#/components/schemas/AwaitingFeedback"
        pagination:
          description: "This container provides pagination information for the returned\
            \ line items awaiting feedback (as filtered)."
          $ref: "#/components/schemas/Pagination"
      description: "This type defines the fields for the <b>getItemsAwaitingFeedback</b>\
        \ response."
    Comment:
      type: "object"
      properties:
        commentPeriod:
          description: "This container indicates the timing of a feedback comment\
            \ based on when it was left. It is only returned if a comment was provided.\
            \ Possible values are 30 days, 90 days, 180 days, 365 days, or 5 years:\
            \ <br><ul><li>Less than 30 days: 30 DAY</li> <li>Over 30 but less than\
            \ 90 days: 90 DAY</li> <li>Over 90 but less than 180 days: 180 DAY</li>\
            \ <li>Over 180 but less than 365 days: 365 DAY</li> <li>More than 365\
            \ days: 5 YEAR</li></ul>"
          $ref: "#/components/schemas/CommentCommentPeriod"
        commentText:
          type: "string"
          description: "The text of the feedback comment, follow-up, or reply. HTML\
            \ formatting and personal information (for example, phone numbers) are\
            \ not allowed. This field is returned if a comment was provided for the\
            \ feedback entry. If the comment was removed due to eBay policy, this\
            \ field will contain '<code>--</code>' and the <b>commentTextRemovedPerPolicy</b>\
            \ field will return <code>true</code>."
        commentTextRemovedPerPolicy:
          type: "boolean"
          description: "If <code>true</code>, this boolean indicates the feedback\
            \ follow-up or reply comment text was removed per eBay policy.  This field\
            \ is only returned when a <b>followupComment</b> container is returned."
        state:
          type: "string"
          description: "This enumerated value indicates the state of the feedback\
            \ (for example, <code>ENTERED</code>). This can be the state of the feedback\
            \ comment, the follow-up comment, or the reply comment. For implementation\
            \ help, refer to <a href='https://developer.ebay.com/api-docs/commerce/feedback/types/fdb:FeedbackCommentStateEnum'>eBay\
            \ API documentation</a>"
      description: "This type provides the details of the feedback comment left by\
        \ the user."
    CommentCommentPeriod:
      type: "object"
      properties:
        unit:
          type: "string"
          description: "Unit of time for the <b>value</b>. Supported values: <code>DAY</code>,\
            \ or <code>YEAR</code>."
        value:
          type: "integer"
          description: "Value of the time period expressed in the period contained\
            \ in the <b>unit</b>. Supported values: <code>30</code>, <code>60</code>,\
            \ or <code>365</code>. <p>See the <a href=\"/api-docs/commerce/feedback/resources/feedback/methods/getFeedback#response.feedbackEntries.feedbackComment.commentPeriod\"\
            >commentPeriod</a> container for more information.</p>"
          format: "int32"
      description: "This type provides fields that descrbes timing associated with\
        \ the comment."
    Error:
      type: "object"
      properties:
        category:
          type: "string"
          description: "Identifies the type of erro."
        domain:
          type: "string"
          description: "Name for the primary system where the error occurred. This\
            \ is relevant for application errors."
        errorId:
          type: "integer"
          description: "A unique number to identify the error."
          format: "int32"
        inputRefIds:
          type: "array"
          description: "An array of request elements most closely associated to the\
            \ error."
          items:
            type: "string"
        longMessage:
          type: "string"
          description: "A more detailed explanation of the error."
        message:
          type: "string"
          description: "Information on how to correct the problem, in the end user's\
            \ terms and language where applicable."
        outputRefIds:
          type: "array"
          description: "An array of request elements most closely associated to the\
            \ error."
          items:
            type: "string"
        parameters:
          type: "array"
          description: "An array of name/value pairs that describe details the error\
            \ condition. These are useful when multiple errors are returned."
          items:
            $ref: "#/components/schemas/ErrorParameter"
        subdomain:
          type: "string"
          description: "Further helps indicate which subsystem the error is coming\
            \ from. System subcategories include: Initialization, Serialization, Security,\
            \ Monitoring, Rate Limiting, etc."
      description: "This type defines the fields that can be returned in an error."
    ErrorParameter:
      type: "object"
      properties:
        name:
          type: "string"
          description: "The object of the error."
        value:
          type: "string"
          description: "The value of the object."
    FeedbackDetail:
      type: "object"
      properties:
        automatedFeedback:
          type: "boolean"
          description: "If the returned value is <code>true</code>, feedback was generated\
            \ and added automatically by eBay. If a seller has a feedback score 10\
            \ or less, eBay automatically leaves feedback. The buyer can choose to\
            \ override the eBay feedback and leave feedback normally. <br><p><span\
            \ class=\"tablenote\"><span style=\"color:#004680\"><strong>Note: </strong>Detailed\
            \ Seller Ratings (DSRs) are not provided by ebay, only a predefined comment\
            \ and a positive rating.</span></p>"
        commentType:
          type: "string"
          description: "This enumerated value indicates the type of feedback: <code>POSITIVE</code>,\
            \ <code>NEUTRAL</code>, <code>NEGATIVE</code>. <br><p><span class=\"tablenote\"\
            ><span style=\"color:#004680\"><strong>Note: </strong>Sellers can only\
            \ leave positive feedback for buyers.</span></p> For implementation help,\
            \ refer to <a href='https://developer.ebay.com/api-docs/commerce/feedback/types/fdb:FeedbackRatingValuesEnum'>eBay\
            \ API documentation</a>"
        eligibleForRevision:
          type: "boolean"
          description: "This boolean indicates whether the feedback is eligible for\
            \ revision. If returned as <code>true</code>, it means the feedback can\
            \ be modified. Feedback that is older than 30 days or has already been\
            \ revised once cannot be erased or further revised."
        feedbackComment:
          description: "This container provides the feedback comment left by a user\
            \ when submitting feedback for a seller or buyer."
          $ref: "#/components/schemas/Comment"
        feedbackEnteredDate:
          type: "string"
          description: "The timestamp when the feedback was submitted."
        feedbackEnteredPeriod:
          description: "This container represents the duration since feedback was\
            \ entered, expressed as a numeric value and a unit of time in days."
          $ref: "#/components/schemas/FeedbackEnteredPeriod"
        feedbackId:
          type: "string"
          description: "The unique identifier of the feedback entry."
        feedbackRatings:
          type: "array"
          description: "This array contains a list of ratings attached to feedback.<br><p><span\
            \ class=\"tablenote\"><span style=\"color:#004680\"><strong>Note: </strong>This\
            \ array only applies to buyers feedback for sellers (sellers can only\
            \ give positive feedback to buyers).</span></p>"
          items:
            $ref: "#/components/schemas/FeedbackRating"
        feedbackScore:
          type: "integer"
          description: "The feedback receiver's feedback score after receiving this\
            \ specific feedback."
          format: "int32"
        feedbackState:
          type: "string"
          description: "This enumerated value indicates the current state of the feedback\
            \ entry (for example, <code>ENTERED</code>). For implementation help,\
            \ refer to <a href='https://developer.ebay.com/api-docs/commerce/feedback/types/fdb:FeedbackStateEnum'>eBay\
            \ API documentation</a>"
        followupComment:
          description: "This container provides the details of any follow-up comment\
            \ left. <br><p><span class=\"tablenote\"><span style=\"color:#004680\"\
            ><strong>Note: </strong>A buyer leaves followup comments, and a seller\
            \ leaves reply comments.</span></p>"
          $ref: "#/components/schemas/Comment"
        hasImages:
          type: "boolean"
          description: "If returned as <code>true</code>, this boolean indicates that\
            \ the feedback entry has one or more images attached. If <code>false</code>,\
            \ there are no images attached."
        images:
          type: "array"
          description: "This array contains the list of attached images."
          items:
            $ref: "#/components/schemas/Image"
        orderLineItemSummary:
          description: "This container provides a summary of the line item associated\
            \ with the feedback entry. <p><span class=\"tablenote\"><span style=\"\
            color:#004680\"><strong>Note: </strong>Certain fields within this container\
            \ are returned only when the request uses the <b>Authorization code grant\
            \ flow</b> (user access token) and the <b>user_id</b> matches the authenticated\
            \ user. These fields are not returned when accessing a different <b>user_id</b>\
            \ or when using the <b>Client credentials grant flow</b> (application\
            \ access token). See <a href=\"#h3-oauth-scope\">OAuth scope</a> for for\
            \ details on the flows and required permissions.</span></p>"
          $ref: "#/components/schemas/OrderLineItemSummary"
        providerUserDetail:
          description: "This container details the attributes of the user who provided\
            \ the feedback."
          $ref: "#/components/schemas/ProviderUserDetail"
        repliedBeforeFollowup:
          type: "boolean"
          description: "If returned as <code>true</code>, this boolean indicates the\
            \ feedback reply was given by the seller before the follow-up comment\
            \ was given buy the buyer."
        replyComment:
          description: "This container provides the details of any reply to the feedback.<br><p><span\
            \ class=\"tablenote\"><span style=\"color:#004680\"><strong>Note: </strong>A\
            \ buyer leaves followup comments, and a seller leaves reply comments.</span></p>"
          $ref: "#/components/schemas/Comment"
        topics:
          type: "array"
          description: "This array provides descriptions of AI-generated insights\
            \ related to a feedback entry for the specified <a href=\"/api-docs/commerce/feedback/resources/feedback/methods/getFeedback#uri.filter\"\
            \ >filter</a> topic. The feedback provided is considered relevant to the\
            \ requested <b>topic</b>. For example, when using the request parameter\
            \ filter of <code>topics:product-satisfaction</code>, the returned array\
            \ might be: <p><pre>{<br>  \"coarseTopic\" : \"product-satisfaction\"\
            ,<br>  \"highlightedTexts\" : [<br>    \"This machine is amazing\",<br>\
            \    \"Very happy with this purchase\"<br>    ],<br>  \"sentiment\" :\
            \ \"Positive\"<br>}</pre></p><p>If no topics exist for that feedback,\
            \ an empty array is returned.</p>"
          items:
            $ref: "#/components/schemas/Topic"
      description: "This type provides attributes for returned feedback entries."
    FeedbackEnteredPeriod:
      type: "object"
      properties:
        unit:
          type: "string"
          description: "The unit for the feedback entry period's <b>value</b>. Supported\
            \ value: <code>DAY</code>."
        value:
          type: "integer"
          description: "The value for the feedback entry period, specified in units\
            \ of <b>unit</b>. Supported values: <code>7</code>, <code>30</code>, <code>90</code>,\
            \ <code>180</code>, or <code>365</code>."
          format: "int32"
      description: "This type specifies the amount of time elapsed associated with\
        \ a feedback entry."
    FeedbackMetrics:
      type: "object"
      properties:
        metricName:
          type: "string"
          description: "This enumerated value specifies the type of feedback aggregation.\
            \ For example, <code>AVG</code> would indicate the feedback returned represents\
            \ the average value of the feedback. See <b>metricValue</b> for the value\
            \ of the returned feedback. For implementation help, refer to <a href='https://developer.ebay.com/api-docs/commerce/feedback/types/fdb:FeedbackAggregationTypeEnum'>eBay\
            \ API documentation</a>"
        metricValue:
          type: "number"
          description: "The decimal value of the specified metric. For example, 55.8\
            \ would represent a value associated with the <b>metricName</b> (see <b>metricName</b>\
            \ for interpretation and units)."
      description: "This type provides fields for the array of metrics associated\
        \ with feedback aggregation."
    FeedbackRating:
      type: "object"
      properties:
        ratingType:
          type: "string"
          description: "This enumerated value indicates the type of rating (for example,\
            \ <code>OVERALL_EXPERIENCE</code>, <code>DSR_ITEM_AS_DESCRIBED</code>).\
            \ For implementation help, refer to <a href='https://developer.ebay.com/api-docs/commerce/feedback/types/fdb:FeedbackRatingTypeEnum'>eBay\
            \ API documentation</a>"
        value:
          type: "string"
          description: "The value assigned to the rating, specified as a string representing\
            \ a number from <code>1</code> to <code>5</code>, with <code>1</code>\
            \ representing the lowest rating and <code>5</code> representing the highest\
            \ rating."
      description: "This type provides for fields in ratings attached to feedback."
    FeedbackRatingAcceptableValue:
      type: "object"
      properties:
        enabled:
          type: "boolean"
          description: "If <code>true</code>, this boolean indicates that this value\
            \ is enabled and selectable."
        value:
          type: "string"
          description: "The value that can be selected for feedback. For most <b>ratingType</b>\
            \ values, this is <code>1</code> through <code>5</code>, with <code>1</code>\
            \ representing the lowest rating and <code>5</code> representing the highest\
            \ rating. For <b>ratingType</b> of <code>OVERALL_EXPERIENCE</code>, this\
            \ can be <code>POSITIVE</code>, <code>NEGATIVE</code>, and <code>NEUTRAL</code>.\
            \ These are the same values as used with the <b>leaveFeedback</b> methods."
        valueLabel:
          type: "string"
          description: "This field provides information about the corresponding <b>value</b>."
      description: "This type provides fields for available values for use in a particular\
        \ rating, and whether the value is enabled."
    FeedbackRatingSummary:
      type: "object"
      properties:
        ratingSummaryByRatingType:
          type: "array"
          description: "An array that includes metrics and distributions for each\
            \ rating type."
          items:
            $ref: "#/components/schemas/RatingSummaryByRatingType"
        ratingType:
          type: "string"
          description: "This enumerated value indicates the type of rating being summarized.\
            \ For example, <code>OVERALL_EXPERIENCE</code> indicates the rating applies\
            \ to the overall transaction experience. For implementation help, refer\
            \ to <a href='https://developer.ebay.com/api-docs/commerce/feedback/types/fdb:FeedbackRatingTypeEnum'>eBay\
            \ API documentation</a>"
      description: "This type provides fields for an array containing a summary of\
        \ feedback ratings. Each element provides detailed metrics and distributions\
        \ for specific rating types."
    FeedbackRatingTemplateType:
      type: "object"
      properties:
        acceptableValues:
          type: "array"
          description: "This array contains a list of available values for use in\
            \ a particular rating, and whether the value is enabled. Provided if <b>ratingValueType</b>\
            \ is <code>RANGE</code> or <code>PREDEFINED</code>.<p>The following is\
            \ an example of a predefined list:<pre>[<br>  {<br>    \"value\": \"POSITIVE\"\
            ,<br>    \"valueLabel\": \"Positive\",<br>    \"enabled\": true<br>  },<br>\
            \  {<br>    \"value\": \"NEUTRAL\",<br>    \"valueLabel\": \"Neutral\"\
            ,<br>    \"enabled\": true<br>  },<br>  {<br>    \"value\": \"NEGATIVE\"\
            ,<br>    \"valueLabel\": \"Negative\",<br>    \"enabled\": true<br>  }</br>]</pre>For\
            \ other examples, see the <a href=\"/develop/guides-v2/communications/sell-communications-guide#using-rating-templates\"\
            \  target=\"_blank\">Using rating templates</a>."
          items:
            $ref: "#/components/schemas/FeedbackRatingAcceptableValue"
        defaultValue:
          type: "string"
          description: "The default value preselected for the rating, if set."
        earlyFeedbackMessage:
          type: "string"
          description: "For eligible sellers, a message may be shown requiring a wait\
            \ period before you can leave neutral or negative feedback."
        enabled:
          type: "boolean"
          description: "If returned as <code>true</code>, this boolean indicates that\
            \ the corresponding feedback rating template is enabled for the user to\
            \ provide feedback for this line item. This value will generally be <code>true</code>\
            \ when the user role is a buyer, but <code>false</code> when the user\
            \ role is a seller because buyers do not have Detailed Seller Ratings\
            \ (DSRs)."
        maximumCharactersAllowed:
          type: "integer"
          description: "The maximum number of characters allowed to be used for a\
            \ rating that uses free text. It is only applicable for a rating whose\
            \ <b>ratingValueType</b> is <code>FREETEXT</code>. <p><b>Maximum: </b>500</p>"
          format: "int32"
        multiValueRating:
          type: "boolean"
          description: "If returned as <code>true</code>, multiple values can be specified\
            \ for the rating."
        ratingKey:
          type: "string"
          description: "This enumerated value indicates the type of rating that is\
            \ tracked for the seller. All of the metadata returned under each node\
            \ for the <b>ratingTemplates</b> array will apply to this rating type.\
            \ For example, the value <code>OVERALL_EXPERIENCE</code> indicates the\
            \ rating is for the overall transaction experience. For implementation\
            \ help, refer to <a href='https://developer.ebay.com/api-docs/commerce/feedback/types/fdb:FeedbackRatingTypeEnum'>eBay\
            \ API documentation</a>"
        ratingLabel:
          type: "string"
          description: "This field provides more details about and/or provides guidance\
            \ on the corresponding rating type. For example, the rating label of <b>Rate\
            \ this transaction</b> describes the feedback for the user to enter for\
            \ an <code>OVERALL_EXPERIENCE</code> <b>ratingKey</b>."
        ratingValueType:
          type: "string"
          description: "This enumerated value indicates the type of data used to provide\
            \ the specific feedback rating.<br><p>If set to <code>PREDEFINED</code>\
            \ or <code>RANGE</code>, is returned here, more information on the supported\
            \ values will be returned under the <b>acceptableValues</b> array. If\
            \ <code>FREETEXT</code> is returned here, the maximum number of characters\
            \ supported can be seen in the <b>maximumCharactersAllowed</b> field.</p>\
            \ For implementation help, refer to <a href='https://developer.ebay.com/api-docs/commerce/feedback/types/fdb:FeedbackRatingValueTypeEnum'>eBay\
            \ API documentation</a>"
        required:
          type: "boolean"
          description: "If returned as <code>true</code>, this rating type is required\
            \ when leaving feedback."
      description: "This type defines fields for user feedback collection, including\
        \ acceptable values, a default preselection value, and an early feedback message.\
        \ It also provides fields to enable the template, and limits and options for\
        \ freetext character, multi-value rating, and other similar features."
    FeedbackRatingValueDistribution:
      type: "object"
      properties:
        count:
          type: "integer"
          description: "An integer representing the number of occurrences for a specific\
            \ feedback rating <b>value</b>. For example, for the <code>POSITIVE</code>\
            \ <b>value</b>, a <code>3</code> returned as the <b>count</b> represents\
            \ three positive ratings were returned."
          format: "int32"
        value:
          type: "string"
          description: "A string indicating the specific feedback rating value. Supported\
            \ values include: <code>POSITIVE</code>, <code>NEUTRAL</code>, <code>NEGATIVE</code>,\
            \ <code>1</code>, <code>2</code>, <code>3</code>, <code>4</code>, and\
            \ <code>5</code>."
      description: "This type provides field for an array listing the distribution\
        \ values of the feedback ratings."
    GetFeedbackRatingSummaryResponse:
      type: "object"
      properties:
        feedbackRatingSummary:
          type: "array"
          description: "An array containing a summary of feedback ratings. Each element\
            \ provides detailed metrics and distributions for specific rating types."
          items:
            $ref: "#/components/schemas/FeedbackRatingSummary"
      description: "This type defines the fields for the <b>getFeedbackRatingSummary</b>\
        \ response."
    GetFeedbackResponse:
      type: "object"
      properties:
        feedbackEntries:
          type: "array"
          description: "This array contains a list of feedback entries that meet the\
            \ specified criteria."
          items:
            $ref: "#/components/schemas/FeedbackDetail"
        pagination:
          description: "This container provides pagination information for the returned\
            \ feedback response (as filtered)."
          $ref: "#/components/schemas/Pagination"
      description: "This type defines the fields for the <b>getFeedback</b> response."
    Image:
      type: "object"
      properties:
        url:
          type: "string"
          description: "This field provides the URL of an attached image and is included\
            \ in the response whenever an image is attached."
      description: "This type provides a field for image URLs."
    ItemsAwaitingFeedbackCount:
      type: "object"
      properties:
        asBuyer:
          type: "integer"
          description: "The number of line items for which feedback is pending from\
            \ the user in the buyer role."
          format: "int32"
        asSeller:
          type: "integer"
          description: "The number of line items for which feedback is pending from\
            \ the user in the seller role."
          format: "int32"
      description: "This type returns the number of line items awaiting feedback."
    LeaveFeedbackRequest:
      type: "object"
      properties:
        commentText:
          type: "string"
          description: "Use this field to provide the feedback left by the user, describing\
            \ their experience with the line item of the transaction. No HTML formatting\
            \ or personal information (such as phone numbers) is permitted.<br><p><b>Maximum\
            \ length:</b> 500 characters</p>"
        commentType:
          type: "string"
          description: "Set this enumerated value to indicate the overall rating of\
            \ the transaction: <code>POSITIVE</code>, <code>NEUTRAL</code>, or <code>NEGATIVE</code>.<br><p><span\
            \ class=\"tablenote\"><span style=\"color:#004680\"><strong>Note: </strong>Sellers\
            \ can only provide positive feedback.</span></p> For implementation help,\
            \ refer to <a href='https://developer.ebay.com/api-docs/commerce/feedback/types/fdb:FeedbackRatingValuesEnum'>eBay\
            \ API documentation</a>"
        images:
          type: "array"
          description: "Use this array to optionally list up to 5 images attached\
            \ to the feedback."
          items:
            $ref: "#/components/schemas/Image"
        listingId:
          type: "string"
          description: "Use this field to provide the listing ID related to the transaction."
        orderLineItemId:
          type: "string"
          description: "Use this field to provide the unique identifier of the line\
            \ item for this feedback."
        sellerRatings:
          type: "array"
          description: "Use this array to list ratings for specific aspects of the\
            \ seller's performance."
          items:
            $ref: "#/components/schemas/SellerRating"
        transactionId:
          type: "string"
          description: "Use this field to provide the unique identifier of the transaction\
            \ for this feedback."
      description: "This type provides fields available to leave feedback in the <b>leaveFeedback</b>\
        \ request."
    LeaveFeedbackResponse:
      type: "object"
      properties:
        feedbackId:
          type: "string"
          description: "The unique ID assigned to the submitted feedback."
      description: "This type defines the fields for the <b>leaveFeedback</b> response\
        \ for feedback that has been left."
    ListingPrice:
      type: "object"
      properties:
        currency:
          type: "string"
          description: "This field provides the three-letter <a href=\"https://www.iso.org/iso-4217-currency-codes.html\"\
            \  target=\"_blank\">ISO 4217</a> code that represents the currency of\
            \ the amount in the value field. Both the <b>value</b> and <b>currency</b>\
            \ fields are always returned when expressing prices."
        value:
          type: "number"
          description: "This field contains the numerical value of the listing price\
            \ in the currency specified in the <b>currency</b> field. Both the <b>value</b>\
            \ and <b>currency</b> fields are always returned when expressing prices."
      description: "This type provides details about the price of the listing awaiting\
        \ feedback."
    OrderLineItemAttribute:
      type: "object"
      properties:
        name:
          type: "string"
          description: "This enumerated value indicates an attribute of the line item.\
            \ The <b>value</b> field indicates if the attribute applies. For implementation\
            \ help, refer to <a href='https://developer.ebay.com/api-docs/commerce/feedback/types/fdb:OrderLineItemAttributesEnum'>eBay\
            \ API documentation</a>"
        value:
          type: "string"
          description: "If returned as <code>true</code>, the line item attribute\
            \ <b>name</b> applies; if returned as <code>false</code>, the attribute\
            \ does not apply."
      description: "This type describes line item attributes."
    OrderLineItemSummary:
      type: "object"
      properties:
        listingId:
          type: "string"
          description: "This field provides the unique identifier for the listing\
            \ associated with the feedback entry. Conditionally returned based on\
            \ the authorization flow and user context. See <a href=\"/api-docs/commerce/feedback/resources/feedback/methods/getFeedback#response.feedbackEntries.orderLineItemSummary\"\
            >orderLineItemSummary</a> for details on when this field is included."
        listingPrice:
          description: "This container provides the sale price of the listing. Conditionally\
            \ returned based on the authorization flow and user context. See <a href=\"\
            /api-docs/commerce/feedback/resources/feedback/methods/getFeedback#response.feedbackEntries.orderLineItemSummary\"\
            >orderLineItemSummary</a> for details on when this field is included."
          $ref: "#/components/schemas/ListingPrice"
        listingTitle:
          type: "string"
          description: "This field contains the title of the listing. Conditionally\
            \ returned based on the authorization flow and user context. See <a href=\"\
            /api-docs/commerce/feedback/resources/feedback/methods/getFeedback#response.feedbackEntries.orderLineItemSummary\"\
            >orderLineItemSummary</a> for details on when this field is included."
        orderLineItemAttributes:
          type: "array"
          description: "This array describes order line attributes including names\
            \ and values of a transaction."
          items:
            $ref: "#/components/schemas/OrderLineItemAttribute"
        orderLineItemId:
          type: "string"
          description: "The unique identifier of the line item for this feedback.\
            \ Conditionally returned based on the authorization flow and user context.\
            \ See <a href=\"/api-docs/commerce/feedback/resources/feedback/methods/getFeedback#response.feedbackEntries.orderLineItemSummary\"\
            >orderLineItemSummary</a> for details on when this field is included."
        transactionPeriod:
          description: "This container indicates if the time since the item was bought\
            \ on ebay is less than, more than, or equal to 90 days"
          $ref: "#/components/schemas/TransactionPeriod"
      description: "This type provides fields for a summary of the line item related\
        \ to feedback."
    Pagination:
      type: "object"
      properties:
        count:
          type: "integer"
          description: "This value indicates the number of feedback entries on the\
            \ current response page."
          format: "int32"
        limit:
          type: "integer"
          description: "The value of the <b>limit</b> parameter submitted in the request.\
            \ This is the maximum number of line items, as filtered, awaiting feedback\
            \ to return per page from the result set. This field indicates the number\
            \ of line items returned per page of data. <p><span class=\"tablenote\"\
            ><span style=\"color:#004680\"><strong>Note: </strong>If this is the last\
            \ or only page of the result set, the page may contain fewer line items\
            \ than the <b>limit</b> value. </span></p><p>If a <b>limit</b> parameter\
            \ was not included in the request, this value will default to <code>25</code>,\
            \ returning up to 25 line items on each page.</p><p><b>Default: </b>25</p>"
          format: "int32"
        next:
          type: "string"
          description: "The relative URI for the next page of results starting with\
            \ the resource name. This URI is returned if there is an additional page\
            \ of results in the result set."
        offset:
          type: "integer"
          description: "The value of the <b>offset</b> parameter submitted in the\
            \ request. This field indicates how many results were skipped in the response.\
            \ If an <b>offset</b> parameter was not included in the request, this\
            \ value will default to <code>0</code>, returning the first page of results.<p><b>Default:\
            \ </b>0</p>"
          format: "int32"
        prev:
          type: "string"
          description: "The relative URI for the previous page of results starting\
            \ with the resource name. This URI is returned if there is a previous\
            \ page of results in the result set.</p>"
        total:
          type: "integer"
          description: "The total number of line items available that match the filter\
            \ criteria. <p><span class=\"tablenote\"><span style=\"color:#004680\"\
            ><strong>Note: </strong>If the total value exceeds the limit value, there\
            \ are multiple pages of results.</span></p>"
          format: "int32"
      description: "This type provides pagination information for the returned line\
        \ items."
    Period:
      type: "object"
      properties:
        unit:
          type: "string"
          description: "The unit of the period's <b>value</b>. Supported value: <code>DAY</code>."
        value:
          type: "integer"
          description: "The value for the feedback period, specified in units of <b>unit</b>.\
            \ Supported value: <code>90</code>."
          format: "int32"
      description: "This type provides fields for the time period on which the feedback\
        \ summary is calculated."
    ProviderUserDetail:
      type: "object"
      properties:
        feedbackScore:
          type: "integer"
          description: "This integer indicates the feedback score of the feedback\
            \ provider at the time of providing this specific feedback."
          format: "int32"
        feedbackStar:
          type: "string"
          description: "This enumerated value provides the visual star representation\
            \ of the feedback score (for example, <code>YELLOW_STAR</code>). For implementation\
            \ help, refer to <a href='https://developer.ebay.com/api-docs/commerce/feedback/types/fdb:FeedbackStarTypeEnum'>eBay\
            \ API documentation</a>"
        role:
          type: "string"
          description: "This enumerated value indicates the user's role in the transaction\
            \ (<code>BUYER</code> or <code>SELLER</code>). For implementation help,\
            \ refer to <a href='https://developer.ebay.com/api-docs/commerce/feedback/types/fdb:UserRoleEnum'>eBay\
            \ API documentation</a>"
        userAttributes:
          type: "array"
          description: "This array lists additional attributes that relate to the\
            \ user (such as verification status)."
          items:
            $ref: "#/components/schemas/ProviderUserDetailUserAttributes"
        userId:
          type: "string"
          description: "This field indicates the unique identifier of the user who\
            \ gave the feedback.<br><br><span class=\"tablenote\"><b>Note:</b> Select\
            \ developers will not receive username data for U.S. users through this\
            \ field. Instead, an immutable user ID will be returned in its place.\
            \ For more information, please refer to <a href=\"/api-docs/static/data-handling-update.html\"\
            \ target=\"_blank\">Data Handling Compliance</a>.</span>"
      description: "This type provides the details of the user who provided the feedback\
        \ of a <b>getFeedback</b> response."
    ProviderUserDetailUserAttributes:
      type: "object"
      properties:
        name:
          type: "string"
          description: "This enumerated value indicates an attribute of the user (for\
            \ example, <code>USER_VERIFIED</code>). The <b>value</b> field indicates\
            \ if the attribute applies. For implementation help, refer to <a href='https://developer.ebay.com/api-docs/commerce/feedback/types/fdb:UserAttributeEnum'>eBay\
            \ API documentation</a>"
        value:
          type: "string"
          description: "If returned as <code>true</code>, the user attribute <b>name</b>\
            \ applies; if returned as <code>false</code>, the attribute does not apply."
      description: "This type defines the attributes of the user who provided the\
        \ feedback of a <b>getFeedback</b> response."
    RatingSummaryByRatingType:
      type: "object"
      properties:
        feedbackMetrics:
          type: "array"
          description: "An array of metrics associated with feedback aggregation."
          items:
            $ref: "#/components/schemas/FeedbackMetrics"
        feedbackRatingValueDistribution:
          type: "array"
          description: "An array listing the distribution values of the feedback ratings."
          items:
            $ref: "#/components/schemas/FeedbackRatingValueDistribution"
        period:
          description: "The time period on which the feedback summary is calculated."
          $ref: "#/components/schemas/Period"
        userRoleType:
          type: "string"
          description: "This enumerated value indicates the user's role in the feedback\
            \  (<code>BUYER</code> or <code>SELLER</code>). For implementation help,\
            \ refer to <a href='https://developer.ebay.com/api-docs/commerce/feedback/types/fdb:UserRoleEnum'>eBay\
            \ API documentation</a>"
      description: "This type provides fields for an array that includes metrics and\
        \ distributions for each rating type."
    RespondToFeedbackRequest:
      type: "object"
      properties:
        feedbackId:
          type: "string"
          description: "Use this field to provide the unique identifier for the feedback\
            \ being responded to, used to specify the feedback entry associated with\
            \ the feedback response. This value can be returned using the <a href=\"\
            /api-docs/commerce/feedback/resources/feedback/methods/getFeedback\" \
            \ target=\"_blank\">getFeedback</a> method (<a href=\"/api-docs/commerce/feedback/resources/feedback/methods/getFeedback#response.feedbackEntries.feedbackId\"\
            \  target=\"_blank\">feedbackId</a> field)."
        recipientUserId:
          type: "string"
          description: "Use this field to provide the identifier of the user who provided\
            \ the original feedback. This value can be returned using the <a href=\"\
            /api-docs/commerce/feedback/resources/feedback/methods/getFeedback\" \
            \ target=\"_blank\">getFeedback</a> method (<a href=\"/api-docs/commerce/feedback/resources/feedback/methods/getFeedback#response.feedbackEntries.providerUserDetail.userId\"\
            \  target=\"_blank\">userId</a> field).<br><br><span class=\"tablenote\"\
            ><b>Note:</b> Both usernames and public user IDs will be accepted in this\
            \ field. For more information, please refer to <a href=\"/api-docs/static/data-handling-update.html\"\
            \ target=\"_blank\">Data Handling Compliance</a>.</span>"
        responseText:
          type: "string"
          description: "Use this field to provide the text content of the response.\
            \ This field is used to provide additional context or address the feedback\
            \ given by the order partner. No HTML formatting or personal information\
            \ (such as phone numbers) is permitted.<br><br><b>Maximum length:</b>\
            \ 500 characters."
        responseType:
          type: "string"
          description: "Set this enumerated value to describe the type of response\
            \ being submitted (for example, a <code>REPLY</code> or a <code>FOLLOW_UP</code>).\
            \ For implementation help, refer to <a href='https://developer.ebay.com/api-docs/commerce/feedback/types/api:ResponseTypeEnum'>eBay\
            \ API documentation</a>"
      description: "The type that defines the fields for the <b>respondToFeedback</b>\
        \ request."
    SellerRating:
      type: "object"
      properties:
        key:
          type: "string"
          description: "The enumerated value of the category being rated, such as\
            \ delivery timeliness (<code>ON_TIME_DELIVERY</code>). For implementation\
            \ help, refer to <a href='https://developer.ebay.com/api-docs/commerce/feedback/types/api:KeyEnum'>eBay\
            \ API documentation</a>"
        value:
          type: "string"
          description: "The value assigned for the selected category. Use a value\
            \ of <code>1</code> through <code>5</code>, with the <code>1</code> being\
            \ the lowest rating and <code>5</code> being the highest."
      description: "This type provides fields for specific aspects of the seller's\
        \ performance."
    Topic:
      type: "object"
      properties:
        coarseTopic:
          type: "string"
          description: "The main topic (or category) detected in the comment. See\
            \ the available <b>topics</b> in <a href=\"/api-docs/commerce/feedback/resources/feedback/methods/getFeedback#uri.filter\"\
            >filter</a>."
        fineTopic:
          type: "string"
          description: "<p><span class=\"tablenote\"><span style=\"color:#004680\"\
            ><strong>Note: </strong>Fine topics are not currently  supported.</span></p>A\
            \ more specific detail or subtopic related to the coarse topic. "
        highlightedTexts:
          type: "array"
          description: "This array lists any text snippets, phrases, or examples,\
            \ from the feedback that supports the detected topic."
          items:
            type: "string"
        sentiment:
          type: "string"
          description: "This field indicates a classification of the feedback, whether\
            \ the feedback is <code>Positive</code>, <code>Negative</code>, or <code>Neutral</code>."
      description: "This type provides subject-based fields derived from feedback."
    TransactionPeriod:
      type: "object"
      properties:
        period:
          description: "This container indicates if the time since the item was bought\
            \ on ebay is less than, more than, or equal to 90 days."
          $ref: "#/components/schemas/Period"
        thresholdType:
          type: "string"
          description: "This enumerated value indicates whether a transaction <a href=\"\
            /api-docs/commerce/feedback/resources/feedback/methods/getFeedback#response.feedbackEntries.orderLineItemSummary.transactionPeriod.period\"\
            \ >period</a> exceeds, falls short, or matches the threshold. You can\
            \ use this field to trigger specific logic or actions based on whether\
            \ a transaction period exceeds, falls short, or matches the threshold.\
            \ For implementation help, refer to <a href='https://developer.ebay.com/api-docs/commerce/feedback/types/fdb:ThresholdTypeEnum'>eBay\
            \ API documentation</a>"
      description: "This type specifies the amount of time elapsed and the threshold\
        \ associated with a transaction."
  securitySchemes:
    api_auth:
      type: "oauth2"
      description: "The security definitions for this API. Please check individual\
        \ operations for applicable scopes."
      flows: {}
